<template>
  <main>
    <v-container>
      <v-layout row>
        <v-flex sm12 class="text-sm-center" v-if="loading">
          <v-progress-circular indeterminate class="primary--text"></v-progress-circular>
        </v-flex>
        <v-flex sm12 v-else>
          <v-card>
            <v-card-title primary-title>
              <div>
                <div class="headline">{{merchant.courtName}}</div>
                <div class="grey--text">{{merchant.location}}</div>
              </div>
            </v-card-title>
            <v-form method="post" @submit.prevent="saveChanges" ref="merchantForm">
              <v-card-text>
                <v-layout row>
                  <v-flex sm7 class="pr-2">
                    <v-text-field label="Court Name" v-model="merchant['courtName']" :rules="[$rules.required]" required />
                    <v-text-field label="Place" v-model="merchant['location']" :rules="[$rules.required]" required />
                  </v-flex>
                  <v-flex sm5 class="pl-2">
                    <v-text-field label="Assigned to" v-model="merchant['owner']" readonly :hint="merchant.owner ? '' : 'Assign this to a merchant account at User Management section'" persistent-hint />
                  </v-flex>
                </v-layout>
              </v-card-text>
              <v-divider></v-divider>
              <v-card-actions>
                <v-btn flat primary type="submit" :loading="saving" :disabled="saving">
                  Save Changes
                  <span slot="loader">Saving...</span>
                </v-btn>
                <v-dialog v-model="dialog.changesSaved" lazy>
                  <v-card>
                    <v-card-title class="pb-0">
                      <div class="headline">Done</div>
                    </v-card-title>
                    <v-card-text>
                      Changes to this merchant has been saved.
                    </v-card-text>
                    <v-card-actions>
                      <v-spacer />
                      <v-btn class="primary--text" flat @click="dialog.changesSaved = false">Okay</v-btn>
                    </v-card-actions>
                  </v-card>
                </v-dialog>
              </v-card-actions>
            </v-form>
          </v-card>
        </v-flex>
      </v-layout>
    </v-container>
  </main>
</template>

<script>
  export default {
    name: 'merchant',
    data () {
      return {
        loading: true,
        saving: false,
        dialog: {changesSaved: false},
        merchant: {},
        db: this.$database.ref(`merchants/${this.$route.params.id}`)
      }
    },
    methods: {
      saveChanges () {
        this.saving = true
        if (this.$refs.merchantForm.validate()) {
          this.db.set(this.merchant).then(() => {
            this.dialog.changesSaved = true
            this.saving = false
          })
        }
      }
    },
    created () {
      this.db.once('value').then(snapshot => {
        let merchant = snapshot.val()
        this.loading = false
        this.merchant = merchant

        if (merchant.owner) {
          let owner = merchant.owner
          this.merchant.owner = null
          this.$database.ref(`users/${owner}`).once('value').then(snapshot => {
            this.merchant.owner = snapshot.val().fullName
          })
        }
      })
    }
  }
</script>
